## samplv1 0.9.19

=== CMakeLists.txt ===
project(samplv1)

cmake_minimum_required(VERSION 3.1)

set (VERSION "0.9.19")

set (CONFIG_VERSION ${VERSION})
execute_process (
  COMMAND git describe --tags --dirty --abbrev=6
  OUTPUT_VARIABLE GIT_DESCRIBE_OUTPUT
  RESULT_VARIABLE GIT_DESCRIBE_RESULT
  OUTPUT_STRIP_TRAILING_WHITESPACE)
if (GIT_DESCRIBE_RESULT EQUAL 0)
  set (VERSION "${GIT_DESCRIBE_OUTPUT}")
  string (REGEX REPLACE "^[^0-9]+" "" VERSION "${VERSION}")
  string (REGEX REPLACE "^[v1_]+"  "" VERSION "${VERSION}")
  string (REGEX REPLACE "-g"   "git." VERSION "${VERSION}")
  string (REGEX REPLACE "[_|-]+"  "." VERSION "${VERSION}")
  execute_process (
    COMMAND git rev-parse --abbrev-ref HEAD
    OUTPUT_VARIABLE GIT_REVPARSE_OUTPUT
    RESULT_VARIABLE GIT_REVPARSE_RESULT
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  if (GIT_REVPARSE_RESULT EQUAL 0 AND NOT GIT_REVPARSE_OUTPUT STREQUAL "master")
    set (VERSION "${VERSION} [${GIT_REVPARSE_OUTPUT}]")
  endif ()
else ()
  set (VERSION "${VERSION}")
endif ()

set (PACKAGE_NAME "samplv1")
set (PACKAGE_VERSION "${VERSION}")
set (PACKAGE_BUGREPORT "rncbc@rncbc.org")
set (PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
set (PACKAGE_TARNAME "samplv1")

set (CONFIG_BUILD_VERSION "${PACKAGE_VERSION}")

if (CMAKE_BUILD_TYPE)
  set (CONFIG_BUILD_TYPE ${CMAKE_BUILD_TYPE})
else ()
  set (CONFIG_BUILD_TYPE "release")
endif ()

set (CONFIG_DEBUG 0)
if (CONFIG_BUILD_TYPE MATCHES "debug")
  set (CONFIG_DEBUG 1)
endif ()

set (CONFIG_PREFIX "${CMAKE_INSTALL_PREFIX}")

include (GNUInstallDirs)
set (CONFIG_BINDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_BINDIR}")
set (CONFIG_LIBDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
set (CONFIG_DATADIR "${CONFIG_PREFIX}/${CMAKE_INSTALL_DATADIR}")
set (CONFIG_MANDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_MANDIR}")


# Enable JACK standalone build.
option (CONFIG_JACK "Enable JACK stand-alone build (default=yes)" 1)

# Enable JACK session support.
option (CONFIG_JACK_SESSION "Enable JACK session support (default=yes)" 1)

# Enable JACK MIDI support option.
option (CONFIG_JACK_MIDI "Enable JACK MIDI support (default=yes)" 1)

# Enable ALSA MIDI support option.
option (CONFIG_ALSA_MIDI "Enable ALSA MIDI support (default=yes)" 1)

# Enable LV2 plugin build.
option (CONFIG_LV2 "Enable LV2 plug-in build (default=yes)" 1)

option (CONFIG_LV2_UI_X11 "Enable LV2 plug-in X11 UI support (default=yes)" 1)

option (CONFIG_LV2_UI_EXTERNAL "Enable LV2 plug-in External UI support (default=yes)" 1)

option (CONFIG_LV2_UI_IDLE "Enable LV2 UI Idle interface support (default=yes)" 1)

option (CONFIG_LV2_UI_SHOW "Enable LV2 UI Show interface support (default=yes)" 1)

option (CONFIG_LV2_UI_RESIZE "Enable LV2 UI Resize interface support (default=yes)" 1)

option (CONFIG_LV2_PROGRAMS "Enable LV2 plug-in Programs support (default=yes)" 1)

option (CONFIG_LV2_PATCH "Enable LV2 plug-in Patch support (default=yes)" 1)

option (CONFIG_LV2_PORT_EVENT "Enable LV2 plug-in Port-event support (EXPERIMENTAL) (default=yes)" 1)

# Enable librubberband availability.
option (CONFIG_LIBRUBBERBAND "Enable librubberband interface (default=yes)" 1)

# Enable FFTW3 availability.
option (CONFIG_FFTW3 "Enable FFTW3 interface support (default=yes)" 1)

# Enable liblo availability.
option (CONFIG_LIBLO "Enable liblo interface (default=yes)" 1)

# Enable NSM support.
option (CONFIG_NSM "Enable NSM support (default=yes)" 1)


# Fix for new CMAKE_REQUIRED_LIBRARIES policy.
if (POLICY CMP0075)
  cmake_policy (SET CMP0075 NEW)
endif ()

# Fix for CXX_VISIBILITY_PRESET policy.
if (POLICY CMP0063)
  cmake_policy (SET CMP0063 NEW)
  set (CMAKE_CXX_VISIBILITY_PRESET hidden)
  set (CMAKE_VISIBILITY_INLINES_HIDDEN 1)
endif ()

# Check for Qt
find_package (QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets Xml)

#find_package (Qt${QT_VERSION_MAJOR}LinguistTools)

include (CheckIncludeFile)
include (CheckIncludeFiles)
include (CheckIncludeFileCXX)
include (CheckFunctionExists)
include (CheckLibraryExists)

# Make sure we get some subtle optimizations out there...
add_compile_options (-ffast-math)

# Checks for header files.
if (UNIX AND NOT APPLE)
  check_include_files ("fcntl.h;unistd.h;signal.h" HAVE_SIGNAL_H)
endif ()


# Find package modules
find_package (PkgConfig REQUIRED)

# Check for SNDFILE libraries.
pkg_check_modules (SNDFILE REQUIRED sndfile)
if (SNDFILE_FOUND)
  set (CONFIG_SNDFILE 1)
  include_directories (${SNDFILE_INCLUDE_DIRS})
  link_directories (${SNDFILE_LIBRARY_DIRS})
  link_libraries (${SNDFILE_LIBRARIES})
# set (CMAKE_REQUIRED_LIBRARIES "${SNDFILE_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
else ()
  message (FATAL_ERROR "*** SNDFILE library not found.")
  set (CONFIG_SNDFILE 0)
endif ()

# Check for JACK libraries.
if (CONFIG_JACK)
  pkg_check_modules (JACK jack>=0.100.0)
  if (JACK_FOUND)
    include_directories (${JACK_INCLUDE_DIRS})
    link_directories (${JACK_LIBRARY_DIRS})
  # link_libraries (${JACK_LIBRARIES})
    set (CMAKE_REQUIRED_LIBRARIES "${JACK_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
    # Check for JACK MIDI headers availability.
    if (CONFIG_JACK_MIDI)
      check_include_file (jack/midiport.h HAVE_JACK_MIDIPORT_H)
      if (NOT HAVE_JACK_MIDIPORT_H)
        set (CONFIG_JACK_MIDI 0)
      endif ()
    endif ()
    # Check for JACK session headers availability.
    if (CONFIG_JACK_SESSION)
      check_include_file (jack/session.h HAVE_JACK_SESSION_H)
      if (NOT HAVE_JACK_SESSION_H)
        set (CONFIG_JACK_SESSION 0)
      endif ()
    endif ()
    # Check for JACK session event callback availability.
    if (CONFIG_JACK_SESSION)
      check_function_exists (jack_set_session_callback CONFIG_JACK_SESSION)
    endif ()
    # Check for ALSA libraries.
    if (CONFIG_ALSA_MIDI)
      pkg_check_modules (ALSA alsa)
      set (CONFIG_ALSA_MIDI ${ALSA_FOUND})
      if (CONFIG_ALSA_MIDI)
        include_directories (${ALSA_INCLUDE_DIRS})
        link_directories (${ALSA_LIBRARY_DIRS})
        link_libraries (${ALSA_LIBRARIES})
      # set (CMAKE_REQUIRED_LIBRARIES "${ALSA_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
      else ()
        message (WARNING "*** ALSA library not found.")
      endif ()
    endif ()
  else ()
    message (WARNING "*** JACK library not found.")
    set (CONFIG_JACK 0)
  endif ()
endif ()

if (NOT CONFIG_JACK)
  set (CONFIG_JACK_SESSION 0)
  set (CONFIG_JACK_MIDI 0)
  set (CONFIG_ALSA_MIDI 0)
  set (CONFIG_LIBLO 0)
  set (CONFIG_NSM 0)
endif ()

# Check for RUBBERBAND libraries.
if (CONFIG_LIBRUBBERBAND)
  pkg_check_modules (RUBBERBAND rubberband)
  if (RUBBERBAND_FOUND)
    include_directories (${RUBBERBAND_INCLUDE_DIRS})
    link_directories (${RUBBERBAND_LIBRARY_DIRS})
    link_libraries (${RUBBERBAND_LIBRARIES})
  # set (CMAKE_REQUIRED_LIBRARIES "${RUBBERBAND_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
  else ()
    message (WARNING "*** RUBBERBAND library not found.")
    set (CONFIG_LIBRUBBERBAND 0)
  endif ()
endif ()

# Check for FFTW3 libraries.
if (CONFIG_FFTW3)
  pkg_check_modules (FFTW3 fftw3f)
  if (FFTW3_FOUND)
    include_directories (${FFTW3_INCLUDE_DIRS})
    link_directories (${FFTW3_LIBRARY_DIRS})
    link_libraries (${FFTW3_LIBRARIES})
  # set (CMAKE_REQUIRED_LIBRARIES "${FFTW3_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
  else ()
    message (WARNING "*** FFTW3 library not found.")
    set (CONFIG_FFTW3 0)
  endif ()
endif ()

# Check for LIBLO libraries.
if (CONFIG_LIBLO)
  pkg_check_modules (LIBLO liblo)
  if (LIBLO_FOUND)
    include_directories (${LIBLO_INCLUDE_DIRS})
    link_directories (${LIBLO_LIBRARY_DIRS})
    link_libraries (${LIBLO_LIBRARIES})
  # set (CMAKE_REQUIRED_LIBRARIES "${LIBLO_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
  else ()
    message (WARNING "*** LIBLO library not found.")
    set (CONFIG_LIBLO 0)
  endif ()
endif ()

# Check for LV2 support.
if (CONFIG_LV2)
  pkg_check_modules (LV2 lv2)
  if (LV2_FOUND)
    include_directories (${LV2_INCLUDE_DIRS})
    link_directories (${LV2_LIBRARY_DIRS})
    link_libraries (${LV2_LIBRARIES})
  # set (CMAKE_REQUIRED_LIBRARIES "${LV2_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
    # Check for LV2 Atom support.
    check_include_file (lv2/lv2plug.in/ns/ext/atom/atom.h HAVE_LV2_ATOM_H)
    if (NOT HAVE_LV2_ATOM_H)
      set (CONFIG_LV2_ATOM 0)
    else ()
      set (CONFIG_LV2_ATOM 1)
    endif ()
    set (CONFIG_LV2_ATOM_FORGE_OBJECT ${CONFIG_LV2_ATOM})
    set (CONFIG_LV2_ATOM_FORGE_KEY ${CONFIG_LV2_ATOM})
    # Check for LV2 UI support.
    check_include_file (lv2/lv2plug.in/ns/extensions/ui/ui.h HAVE_LV2_UI_H)
    if (NOT HAVE_LV2_UI_H)
      set (CONFIG_LV2_UI 0)
    else ()
      set (CONFIG_LV2_UI 1)
    endif ()
    if (NOT CONFIG_LV2_UI)
      set (CONFIG_LV2_UI_X11 0)
      set (CONFIG_LV2_UI_EXTERNAL 0)
      set (CONFIG_LV2_UI_IDLE 0)
      set (CONFIG_LV2_UI_SHOW 0)
      set (CONFIG_LV2_UI_RESIZE 0)
    endif ()
  else ()
    message (WARNING "*** LV2 SDK not found.")
    set (CONFIG_LV2 0)
  endif ()
endif ()

# Check for LV2 headers.
if (CONFIG_LV2)
  set (LV2_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/src/lv2)
  set (CMAKE_REQUIRED_INCLUDES "${LV2_INCLUDES};${CMAKE_REQUIRED_INCLUDES}")
  include_directories (${LV2_INCLUDES})
else ()
  set (CONFIG_LV2_UI_X11 0)
  set (CONFIG_LV2_UI_EXTERNAL 0)
  set (CONFIG_LV2_UI_IDLE 0)
  set (CONFIG_LV2_UI_SHOW 0)
  set (CONFIG_LV2_UI_RESIZE 0)
  set (CONFIG_LV2_PROGRAMS 0)
  set (CONFIG_LV2_PATCH 0)
endif ()

if (CONFIG_LV2_UI_EXTERNAL)
  check_include_file (lv2_external_ui.h HAVE_LV2_EXTERNAL_UI_H)
  if (NOT HAVE_LV2_EXTERNAL_UI_H)
    set (CONFIG_LV2_UI_EXTERNAL 0)
  endif ()
endif ()

if (CONFIG_LV2_PROGRAMS)
  check_include_file (lv2_programs.h HAVE_LV2_PROGRAMS_H)
  if (NOT HAVE_LV2_PROGRAMS_H)
    set (CONFIG_LV2_PROGRAMS 0)
  endif ()
endif ()

if (CONFIG_LV2_PATCH)
  check_include_file (lv2/lv2plug.in/ns/ext/patch/patch.h HAVE_LV2_PATCH_H)
  if (NOT HAVE_LV2_PATCH_H)
    set (CONFIG_LV2_PATCH 0)
  endif ()
endif ()


add_subdirectory (src)


configure_file (samplv1.spec.in samplv1.spec IMMEDIATE @ONLY)

install (FILES samplv1.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
install (FILES samplv1.fr.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/fr/man1 RENAME samplv1.1)

# Configuration status
macro (SHOW_OPTION text value)
  if (${value})
    message ("${text}: yes")
  else ()
    message ("${text}: no")
  endif ()
endmacro ()


message   ("\n  ${PACKAGE_NAME} ${PACKAGE_VERSION}")
message   ("\n  Build target . . . . . . . . . . . . . . . . . . .: ${CONFIG_BUILD_TYPE}\n")
show_option ("  JACK stand-alone build . . . . . . . . . . . . . ." CONFIG_JACK)
show_option ("  JACK session support . . . . . . . . . . . . . . ." CONFIG_JACK_SESSION)
show_option ("  JACK MIDI support  . . . . . . . . . . . . . . . ." CONFIG_JACK_MIDI)
show_option ("  ALSA MIDI support  . . . . . . . . . . . . . . . ." CONFIG_ALSA_MIDI)
show_option ("  LV2 plug-in build  . . . . . . . . . . . . . . . ." CONFIG_LV2)
show_option ("  LV2 plug-in X11 UI support   . . . . . . . . . . ." CONFIG_LV2_UI_X11)
show_option ("  LV2 plug-in External UI support  . . . . . . . . ." CONFIG_LV2_UI_EXTERNAL)
show_option ("  LV2 plug-in UI Idle interface support  . . . . . ." CONFIG_LV2_UI_IDLE)
show_option ("  LV2 plug-in UI Show interface support  . . . . . ." CONFIG_LV2_UI_SHOW)
show_option ("  LV2 plug-in UI Resize interface support  . . . . ." CONFIG_LV2_UI_RESIZE)
show_option ("  LV2 plug-in Programs support . . . . . . . . . . ." CONFIG_LV2_PROGRAMS)
show_option ("  LV2 plug-in Patch support  . . . . . . . . . . . ." CONFIG_LV2_PATCH)
show_option ("  LV2 plug-in Port-event support (EXPERIMENTAL)  . ." CONFIG_LV2_PORT_EVENT)
show_option ("  Pitch-shifting support (librubberband) . . . . . ." CONFIG_LIBRUBBERBAND)
show_option ("  Pitch-shifting support (fftw3) . . . . . . . . . ." CONFIG_FFTW3)
show_option ("  OSC service support (liblo)  . . . . . . . . . . ." CONFIG_LIBLO)
show_option ("  NSM (New Session Management) support . . . . . . ." CONFIG_NSM)

=== src/CMakeLists.txt ===
# project(samplv1)

include_directories (
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
)

configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

set (HEADERS
  samplv1.h
  samplv1_config.h
  samplv1_filter.h
  samplv1_formant.h
  samplv1_pshifter.h
  samplv1_resampler.h
  samplv1_sample.h
  samplv1_wave.h
  samplv1_ramp.h
  samplv1_list.h
  samplv1_fx.h
  samplv1_reverb.h
  samplv1_param.h
  samplv1_sched.h
  samplv1_tuning.h
  samplv1_programs.h
  samplv1_controls.h
)

set (SOURCES
  samplv1.cpp
  samplv1_config.cpp
  samplv1_formant.cpp
  samplv1_pshifter.cpp
  samplv1_resampler.cpp
  samplv1_sample.cpp
  samplv1_wave.cpp
  samplv1_param.cpp
  samplv1_sched.cpp
  samplv1_tuning.cpp
  samplv1_programs.cpp
  samplv1_controls.cpp
)

qt5_wrap_cpp (MOC_SOURCES ${HEADERS})


set (HEADERS_UI
  samplv1_ui.h
  samplv1widget.h
  samplv1widget_env.h
  samplv1widget_filt.h
  samplv1widget_sample.h
  samplv1widget_wave.h
  samplv1widget_param.h
  samplv1widget_keybd.h
  samplv1widget_preset.h
  samplv1widget_status.h
  samplv1widget_spinbox.h
  samplv1widget_programs.h
  samplv1widget_controls.h
  samplv1widget_control.h
  samplv1widget_palette.h
  samplv1widget_config.h
)

set (SOURCES_UI
  samplv1_ui.cpp
  samplv1widget.cpp
  samplv1widget_env.cpp
  samplv1widget_filt.cpp
  samplv1widget_sample.cpp
  samplv1widget_wave.cpp
  samplv1widget_param.cpp
  samplv1widget_keybd.cpp
  samplv1widget_preset.cpp
  samplv1widget_status.cpp
  samplv1widget_spinbox.cpp
  samplv1widget_programs.cpp
  samplv1widget_controls.cpp
  samplv1widget_control.cpp
  samplv1widget_palette.cpp
  samplv1widget_config.cpp
)

set (FORMS_UI
  samplv1widget.ui
  samplv1widget_control.ui
  samplv1widget_palette.ui
  samplv1widget_config.ui
)

set (RESOURCES_UI
  samplv1.qrc
)

qt_wrap_ui (UI_SOURCES_UI ${FORMS_UI})
qt_wrap_cpp (MOC_SOURCES_UI ${HEADERS_UI})
qt_add_resources (QRC_SOURCES_UI ${RESOURCES_UI})


set (HEADERS_LV2
  samplv1_lv2.h
  samplv1_lv2ui.h
  samplv1widget_lv2.h
)

set (SOURCES_LV2
  samplv1_lv2.cpp
  samplv1_lv2ui.cpp
  samplv1widget_lv2.cpp
)

qt_wrap_cpp (MOC_SOURCES_LV2 ${HEADERS_LV2})


set (HEADERS_JACK
  samplv1_nsm.h
  samplv1_jack.h
  samplv1widget_jack.h
)

set (SOURCES_JACK
  samplv1_nsm.cpp
  samplv1_jack.cpp
  samplv1widget_jack.cpp
)

qt_wrap_cpp (MOC_SOURCES_JACK ${HEADERS_JACK})


add_library (${PROJECT_NAME} STATIC
  ${MOC_SOURCES}
  ${SOURCES}
)

add_library (${PROJECT_NAME}_ui STATIC
  ${UI_SOURCES_UI}
  ${MOC_SOURCES_UI}
  ${QRC_SOURCES_UI}
  ${SOURCES_UI}
)

add_library (${PROJECT_NAME}_lv2 MODULE
  ${MOC_SOURCES_LV2}
  ${SOURCES_LV2}
)

add_executable (${PROJECT_NAME}_jack
  ${MOC_SOURCES_JACK}
  ${SOURCES_JACK}
)


set_target_properties (${PROJECT_NAME}       PROPERTIES CXX_STANDARD 17)
set_target_properties (${PROJECT_NAME}_ui    PROPERTIES CXX_STANDARD 17)
set_target_properties (${PROJECT_NAME}_lv2   PROPERTIES CXX_STANDARD 17)
set_target_properties (${PROJECT_NAME}_jack  PROPERTIES CXX_STANDARD 17)

target_link_libraries (${PROJECT_NAME}       PUBLIC Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Xml)
target_link_libraries (${PROJECT_NAME}_ui    PUBLIC Qt${QT_VERSION_MAJOR}::Widgets ${PROJECT_NAME})
target_link_libraries (${PROJECT_NAME}_lv2   PRIVATE ${PROJECT_NAME}_ui)
target_link_libraries (${PROJECT_NAME}_jack  PRIVATE ${PROJECT_NAME}_ui)

if (CONFIG_SNDFILE)
  target_link_libraries (${PROJECT_NAME} PRIVATE ${SNDFILE_LIBRARIES})
endif ()

if (CONFIG_LIBRUBBERBAND)
  target_link_libraries (${PROJECT_NAME} PRIVATE ${RUBBERBAND_LIBRARIES})
endif ()

if (CONFIG_FFTW3)
  target_link_libraries (${PROJECT_NAME} PRIVATE ${FFTW3_LIBRARIES})
endif ()

if (CONFIG_JACK)
  target_link_libraries (${PROJECT_NAME}_jack PRIVATE ${JACK_LIBRARIES})
endif ()

if (CONFIG_ALSA_MIDI)
  target_link_libraries (${PROJECT_NAME}_jack PRIVATE ${ALSA_LIBRARIES})
endif ()

if (CONFIG_LIBLO)
  target_link_libraries (${PROJECT_NAME}_jack PRIVATE ${LIBLO_LIBRARIES})
endif ()


if (UNIX AND NOT APPLE AND NOT CONFIG_DEBUG)
  add_custom_command(TARGET ${PROJECT_NAME}_lv2  POST_BUILD
    COMMAND strip lib${PROJECT_NAME}_lv2.so)
  add_custom_command(TARGET ${PROJECT_NAME}_jack POST_BUILD
    COMMAND strip ${PROJECT_NAME}_jack)
endif ()


if (UNIX AND NOT APPLE)
  if (CONFIG_PREFIX MATCHES $ENV{HOME})
    set (CONFIG_LV2DIR ${CONFIG_PREFIX}/.lv2)
  else ()
    set (CONFIG_LV2DIR ${CONFIG_LIBDIR}/lv2)
  endif ()
  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${PROJECT_NAME}_lv2.so
     RENAME ${PROJECT_NAME}.so
     DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
  install (FILES ${PROJECT_NAME}.lv2/manifest.ttl
     ${PROJECT_NAME}.lv2/${PROJECT_NAME}.ttl
     ${PROJECT_NAME}.lv2/${PROJECT_NAME}_ui.ttl
     DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
  install (TARGETS ${PROJECT_NAME}_jack RUNTIME
     DESTINATION ${CMAKE_INSTALL_BINDIR})
  install (FILES ${PROJECT_NAME}.desktop
     DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
  install (FILES images/${PROJECT_NAME}.png
     DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps)
  install (FILES images/${PROJECT_NAME}.svg
     DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
  install (FILES appdata/${PROJECT_NAME}.appdata.xml
     DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
  install (FILES mimetypes/${PROJECT_NAME}.xml
     DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages)
  install (FILES mimetypes/application-x-${PROJECT_NAME}-preset.png
     DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/mimetypes)
  install (FILES mimetypes/application-x-${PROJECT_NAME}-preset.svg
     DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/mimetypes)
endif ()

=== debian/changelog ===
samplv1 (0.9.19-1) unstable; urgency=medium

  * New upstream version 0.9.19
  * Enable debugging
  * Update d/watch version to 4

 -- Dennis Braun <d_braun@kabelmail.de>  Tue, 22 Dec 2020 00:55:23 +0100

samplv1 (0.9.18-2) unstable; urgency=medium

  * Bump S-V to 4.5.1
  * Re-add allow-stderr for stderr output

 -- Dennis Braun <d_braun@kabelmail.de>  Sun, 13 Dec 2020 17:21:21 +0100

## samplv1 0.9.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,11 @@
-project(samplv1)
-
-cmake_minimum_required(VERSION 3.1)
-
-set (VERSION "0.9.19")
-
-set (CONFIG_VERSION ${VERSION})
+cmake_minimum_required(VERSION 3.10)
+
+project(drumkv1
+  VERSION 0.9.20
+  DESCRIPTION "an old-school polyphonic sampler"
+  LANGUAGES C CXX)
+
+set (CONFIG_VERSION ${PROJECT_VERSION})
 execute_process (
   COMMAND git describe --tags --dirty --abbrev=6
   OUTPUT_VARIABLE GIT_DESCRIBE_OUTPUT
@@ -25,7 +26,7 @@
     set (VERSION "${VERSION} [${GIT_REVPARSE_OUTPUT}]")
   endif ()
 else ()
-  set (VERSION "${VERSION}")
+  set (VERSION "${PROJECT_VERSION}")
 endif ()
 
 set (PACKAGE_NAME "samplv1")
@@ -137,7 +138,7 @@
 find_package (PkgConfig REQUIRED)
 
 # Check for SNDFILE libraries.
-pkg_check_modules (SNDFILE REQUIRED sndfile)
+pkg_check_modules (SNDFILE REQUIRED IMPORTED_TARGET sndfile)
 if (SNDFILE_FOUND)
   set (CONFIG_SNDFILE 1)
   include_directories (${SNDFILE_INCLUDE_DIRS})
@@ -151,7 +152,7 @@
 
 # Check for JACK libraries.
 if (CONFIG_JACK)
-  pkg_check_modules (JACK jack>=0.100.0)
+  pkg_check_modules (JACK IMPORTED_TARGET jack>=0.100.0)
   if (JACK_FOUND)
     include_directories (${JACK_INCLUDE_DIRS})
     link_directories (${JACK_LIBRARY_DIRS})
@@ -177,7 +178,7 @@
     endif ()
     # Check for ALSA libraries.
     if (CONFIG_ALSA_MIDI)
-      pkg_check_modules (ALSA alsa)
+      pkg_check_modules (ALSA IMPORTED_TARGET alsa)
       set (CONFIG_ALSA_MIDI ${ALSA_FOUND})
       if (CONFIG_ALSA_MIDI)
         include_directories (${ALSA_INCLUDE_DIRS})
@@ -204,7 +205,7 @@
 
 # Check for RUBBERBAND libraries.
 if (CONFIG_LIBRUBBERBAND)
-  pkg_check_modules (RUBBERBAND rubberband)
+  pkg_check_modules (RUBBERBAND IMPORTED_TARGET rubberband)
   if (RUBBERBAND_FOUND)
     include_directories (${RUBBERBAND_INCLUDE_DIRS})
     link_directories (${RUBBERBAND_LIBRARY_DIRS})
@@ -218,7 +219,7 @@
 
 # Check for FFTW3 libraries.
 if (CONFIG_FFTW3)
-  pkg_check_modules (FFTW3 fftw3f)
+  pkg_check_modules (FFTW3 IMPORTED_TARGET fftw3f)
   if (FFTW3_FOUND)
     include_directories (${FFTW3_INCLUDE_DIRS})
     link_directories (${FFTW3_LIBRARY_DIRS})
@@ -232,7 +233,7 @@
 
 # Check for LIBLO libraries.
 if (CONFIG_LIBLO)
-  pkg_check_modules (LIBLO liblo)
+  pkg_check_modules (LIBLO IMPORTED_TARGET liblo)
   if (LIBLO_FOUND)
     include_directories (${LIBLO_INCLUDE_DIRS})
     link_directories (${LIBLO_LIBRARY_DIRS})
@@ -353,5 +354,3 @@
 show_option ("  LV2 plug-in Port-event support (EXPERIMENTAL)  . ." CONFIG_LV2_PORT_EVENT)
 show_option ("  Pitch-shifting support (librubberband) . . . . . ." CONFIG_LIBRUBBERBAND)
 show_option ("  Pitch-shifting support (fftw3) . . . . . . . . . ." CONFIG_FFTW3)
-show_option ("  OSC service support (liblo)  . . . . . . . . . . ." CONFIG_LIBLO)
-show_option ("  NSM (New Session Management) support . . . . . . ." CONFIG_NSM)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,14 @@
 # project(samplv1)
 
-include_directories (
-  ${CMAKE_CURRENT_SOURCE_DIR}
-  ${CMAKE_CURRENT_BINARY_DIR}
-)
-
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
+
+set(CMAKE_AUTOUIC ON)
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTORCC ON)
+
+if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
+    file(REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
+endif()
 configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 
 set (HEADERS
@@ -42,8 +46,6 @@
   samplv1_controls.cpp
 )
 
-qt5_wrap_cpp (MOC_SOURCES ${HEADERS})
-
 
 set (HEADERS_UI
   samplv1_ui.h
@@ -94,10 +96,6 @@
   samplv1.qrc
 )
 
-qt_wrap_ui (UI_SOURCES_UI ${FORMS_UI})
-qt_wrap_cpp (MOC_SOURCES_UI ${HEADERS_UI})
-qt_add_resources (QRC_SOURCES_UI ${RESOURCES_UI})
-
 
 set (HEADERS_LV2
   samplv1_lv2.h
@@ -111,8 +109,6 @@
   samplv1widget_lv2.cpp
 )
 
-qt_wrap_cpp (MOC_SOURCES_LV2 ${HEADERS_LV2})
-
 
 set (HEADERS_JACK
   samplv1_nsm.h
@@ -126,28 +122,26 @@
   samplv1widget_jack.cpp
 )
 
-qt_wrap_cpp (MOC_SOURCES_JACK ${HEADERS_JACK})
-
 
 add_library (${PROJECT_NAME} STATIC
-  ${MOC_SOURCES}
+  ${HEADERS}
   ${SOURCES}
 )
 
 add_library (${PROJECT_NAME}_ui STATIC
-  ${UI_SOURCES_UI}
-  ${MOC_SOURCES_UI}
-  ${QRC_SOURCES_UI}
+  ${HEADERS_UI}
   ${SOURCES_UI}
+  ${FORMS_UI}
+  ${RESOURCES_UI}
 )
 
 add_library (${PROJECT_NAME}_lv2 MODULE
-  ${MOC_SOURCES_LV2}
+  ${HEADERS_LV2}
   ${SOURCES_LV2}
 )
 
 add_executable (${PROJECT_NAME}_jack
-  ${MOC_SOURCES_JACK}
+  ${HEADERS_JACK}
   ${SOURCES_JACK}
 )
 
@@ -163,27 +157,27 @@
 target_link_libraries (${PROJECT_NAME}_jack  PRIVATE ${PROJECT_NAME}_ui)
 
 if (CONFIG_SNDFILE)
-  target_link_libraries (${PROJECT_NAME} PRIVATE ${SNDFILE_LIBRARIES})
+  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::SNDFILE)
 endif ()
 
 if (CONFIG_LIBRUBBERBAND)
-  target_link_libraries (${PROJECT_NAME} PRIVATE ${RUBBERBAND_LIBRARIES})
+  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::RUBBERBAND)
 endif ()
 
 if (CONFIG_FFTW3)
-  target_link_libraries (${PROJECT_NAME} PRIVATE ${FFTW3_LIBRARIES})
+  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::FFTW3)
 endif ()
 
 if (CONFIG_JACK)
-  target_link_libraries (${PROJECT_NAME}_jack PRIVATE ${JACK_LIBRARIES})
+  target_link_libraries (${PROJECT_NAME}_jack PRIVATE PkgConfig::JACK)
 endif ()
 
 if (CONFIG_ALSA_MIDI)
-  target_link_libraries (${PROJECT_NAME}_jack PRIVATE ${ALSA_LIBRARIES})
+  target_link_libraries (${PROJECT_NAME}_jack PRIVATE PkgConfig::ALSA)
 endif ()
 
 if (CONFIG_LIBLO)
-  target_link_libraries (${PROJECT_NAME}_jack PRIVATE ${LIBLO_LIBRARIES})
+  target_link_libraries (${PROJECT_NAME}_jack PRIVATE PkgConfig::LIBLO)
 endif ()

=== debian/changelog ===
samplv1 (0.9.20-1) unstable; urgency=medium

  * New upstream version 0.9.20
  * Update d/copyright years

 -- Dennis Braun <d_braun@kabelmail.de>  Wed, 10 Feb 2021 21:14:44 +0100

=== debian/control ===
Source: samplv1
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Dennis Braun <d_braun@kabelmail.de>,
 Alessio Treglia <alessio@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
 automake,
 debhelper-compat (= 13),
 ladspa-sdk,
 libasound2-dev,
 libjack-dev | libjack-jackd2-dev,
 qtbase5-dev,
 qttools5-dev-tools,
 libsndfile1-dev,
 libtool,
 libx11-dev,
 lv2-dev,
 liblo-dev,
Homepage: https://samplv1.sourceforge.io/
Standards-Version: 4.5.1
Vcs-Git: https://salsa.debian.org/multimedia-team/samplv1.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/samplv1
Rules-Requires-Root: no

Package: samplv1
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 samplv1-common (=${source:Version}),
Recommends:
 jackd
Description: polyphonic sampler synthesizer - standalone
 samplv1 is an old-school all-digital polyphonic sampler
 synthesizer with stereo effects.
 .
 Although other samplers like specimen provide more features,
 one could find samplv1 much easier and accessible. Plus, it
 is provided in both forms of a JACK stand-alone client and
 a LV2 plugin.
 .
 This package provides the standalone app.

Package: samplv1-lv2
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 samplv1-common (=${source:Version}),
Replaces: samplv1 (<< 0.7.6)
Breaks: samplv1 (<< 0.7.6)
Provides:
 lv2-plugin
Description: polyphonic sampler synthesizer - LV2 plugin
 samplv1 is an old-school all-digital polyphonic sampler
 synthesizer with stereo effects.
 .
 Although other samplers like specimen provide more features,
 one could find samplv1 much easier and accessible. Plus, it
 is provided in both forms of a JACK stand-alone client and
 a LV2 plugin.
 .
 This package provides the LV2 plugin.

Package: samplv1-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Replaces: samplv1 (<< 0.7.6)
Breaks: samplv1 (<< 0.7.6)
Description: polyphonic sampler synthesizer - common files
 samplv1 is an old-school all-digital polyphonic sampler
 synthesizer with stereo effects.
 .
 Although other samplers like specimen provide more features,
 one could find samplv1 much easier and accessible. Plus, it
 is provided in both forms of a JACK stand-alone client and
 a LV2 plugin.
 .
 This package provides files shared by both the LV2 plugin
 and the standalone application.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

EXTRA_CONFIGURE_ARGS = \
 --enable-debug \
 --enable-jack \
 --enable-jack-midi \
 --enable-jack-session \
 --enable-lv2

export QTDIR=/usr/share/qt5
export QT_SELECT=qt5

ifeq ($(DEB_HOST_ARCH_OS),linux)
EXTRA_CONFIGURE_ARGS += --enable-alsa-midi
else
EXTRA_CONFIGURE_ARGS += --disable-alsa-midi
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CONFIGURE_ARGS)

override_dh_auto_install:
	cp  $(CURDIR)/samplv1.1 $(CURDIR)/samplv1_jack.1
	cp  $(CURDIR)/samplv1.fr.1 $(CURDIR)/samplv1_jack.fr.1
	dh_auto_install
	cp $(CURDIR)/debian/tmp/usr/share/mime/packages/samplv1.xml $(CURDIR)/debian/samplv1-common.sharedmimeinfo

override_dh_clean:
	dh_clean
	rm -f $(CURDIR)/debian/samplv1-common.sharedmimeinfo
	rm -f $(CURDIR)/samplv1_jack.1
	rm -f $(CURDIR)/samplv1_jack.fr.1

## samplv1 0.9.23

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,24 +1,27 @@
-cmake_minimum_required(VERSION 3.10)
-
-project(drumkv1
-  VERSION 0.9.20
+cmake_minimum_required (VERSION 3.13)
+
+project (samplv1
+  VERSION 0.9.23
   DESCRIPTION "an old-school polyphonic sampler"
   LANGUAGES C CXX)
 
 set (CONFIG_VERSION ${PROJECT_VERSION})
 execute_process (
   COMMAND git describe --tags --dirty --abbrev=6
+  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
   OUTPUT_VARIABLE GIT_DESCRIBE_OUTPUT
   RESULT_VARIABLE GIT_DESCRIBE_RESULT
   OUTPUT_STRIP_TRAILING_WHITESPACE)
 if (GIT_DESCRIBE_RESULT EQUAL 0)
   set (VERSION "${GIT_DESCRIBE_OUTPUT}")
   string (REGEX REPLACE "^[^0-9]+" "" VERSION "${VERSION}")
-  string (REGEX REPLACE "^[v1_]+"  "" VERSION "${VERSION}")
+  string (REGEX REPLACE "^1_"      "" VERSION "${VERSION}")
+  string (REGEX REPLACE "^[_vV]+"  "" VERSION "${VERSION}")
   string (REGEX REPLACE "-g"   "git." VERSION "${VERSION}")
-  string (REGEX REPLACE "[_|-]+"  "." VERSION "${VERSION}")
+  string (REGEX REPLACE "[_|-]"   "." VERSION "${VERSION}")
   execute_process (
     COMMAND git rev-parse --abbrev-ref HEAD
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
     OUTPUT_VARIABLE GIT_REVPARSE_OUTPUT
     RESULT_VARIABLE GIT_REVPARSE_RESULT
     OUTPUT_STRIP_TRAILING_WHITESPACE)
@@ -35,17 +38,21 @@
 set (PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
 set (PACKAGE_TARNAME "samplv1")
 
+set (ac_version "${PROJECT_VERSION}")
+set (ac_prefix "${CMAKE_INSTALL_PREFIX}")
+
 set (CONFIG_BUILD_VERSION "${PACKAGE_VERSION}")
 
-if (CMAKE_BUILD_TYPE)
-  set (CONFIG_BUILD_TYPE ${CMAKE_BUILD_TYPE})
+if (CONFIG_DEBUG)
+  set (CMAKE_BUILD_TYPE "Debug")
+endif ()
+if (CMAKE_BUILD_TYPE MATCHES "Debug")
+  set (CONFIG_DEBUG 1)
+endif ()
+if (CONFIG_DEBUG)
+  set (CONFIG_BUILD_TYPE "debug")
 else ()
   set (CONFIG_BUILD_TYPE "release")
-endif ()
-
-set (CONFIG_DEBUG 0)
-if (CONFIG_BUILD_TYPE MATCHES "debug")
-  set (CONFIG_DEBUG 1)
 endif ()
 
 set (CONFIG_PREFIX "${CMAKE_INSTALL_PREFIX}")
@@ -72,7 +79,13 @@
 # Enable LV2 plugin build.
 option (CONFIG_LV2 "Enable LV2 plug-in build (default=yes)" 1)
 
-option (CONFIG_LV2_UI_X11 "Enable LV2 plug-in X11 UI support (default=yes)" 1)
+if (WIN32)
+  option (CONFIG_LV2_UI_WINDOWS "Enable LV2 plug-in Windows UI support (default=yes)" 1)
+  # Windows install target path.
+  set (CONFIG_WINDOWS_LV2_PATH "$ENV{SYSTEMDRIVE}/Program Files/Common Files/LV2" CACHE STRING "Specify Windows LV2 install path")
+else ()
+  option (CONFIG_LV2_UI_X11 "Enable LV2 plug-in X11 UI support (default=yes)" 1)
+endif ()
 
 option (CONFIG_LV2_UI_EXTERNAL "Enable LV2 plug-in External UI support (default=yes)" 1)
 
@@ -99,6 +112,10 @@
 
 # Enable NSM support.
 option (CONFIG_NSM "Enable NSM support (default=yes)" 1)
+
+
+# Enable Qt6 build preference.
+option (CONFIG_QT6 "Enable Qt6 build (default=yes)" 1)
 
 
 # Fix for new CMAKE_REQUIRED_LIBRARIES policy.
@@ -113,8 +130,20 @@
   set (CMAKE_VISIBILITY_INLINES_HIDDEN 1)
 endif ()
 
-# Check for Qt
-find_package (QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
+# Check for Qt...
+if (CONFIG_QT6)
+  find_package (Qt6 QUIET)
+  if (NOT Qt6_FOUND)
+    set (CONFIG_QT6 0)
+  endif ()
+endif ()
+
+if (CONFIG_QT6)
+  find_package (QT QUIET NAMES Qt6)
+else ()
+  find_package (QT QUIET NAMES Qt5)
+endif ()
+
 find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets Xml)
 
 #find_package (Qt${QT_VERSION_MAJOR}LinguistTools)
@@ -135,16 +164,16 @@
 
 
 # Find package modules
-find_package (PkgConfig REQUIRED)
+include (FindPkgConfig)
 
 # Check for SNDFILE libraries.
 pkg_check_modules (SNDFILE REQUIRED IMPORTED_TARGET sndfile)
 if (SNDFILE_FOUND)
+  find_library (SNDFILE_LIBRARY NAMES ${SNDFILE_LIBRARIES} HINTS ${SNDFILE_LIBDIR})
+endif ()
+if (SNDFILE_LIBRARY)
   set (CONFIG_SNDFILE 1)
-  include_directories (${SNDFILE_INCLUDE_DIRS})
-  link_directories (${SNDFILE_LIBRARY_DIRS})
-  link_libraries (${SNDFILE_LIBRARIES})
-# set (CMAKE_REQUIRED_LIBRARIES "${SNDFILE_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
+ #set (CMAKE_REQUIRED_LIBRARIES "${SNDFILE_LIBRARY};${CMAKE_REQUIRED_LIBRARIES}")
 else ()
   message (FATAL_ERROR "*** SNDFILE library not found.")
   set (CONFIG_SNDFILE 0)
@@ -154,10 +183,11 @@
 if (CONFIG_JACK)
   pkg_check_modules (JACK IMPORTED_TARGET jack>=0.100.0)
   if (JACK_FOUND)
-    include_directories (${JACK_INCLUDE_DIRS})
-    link_directories (${JACK_LIBRARY_DIRS})
-  # link_libraries (${JACK_LIBRARIES})
-    set (CMAKE_REQUIRED_LIBRARIES "${JACK_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
+    find_library (JACK_LIBRARY NAMES ${JACK_LIBRARIES} HINTS ${JACK_LIBDIR})
+  endif ()
+  if (JACK_LIBRARY)
+    set (CONFIG_JACK 1)
+    set (CMAKE_REQUIRED_LIBRARIES "${JACK_LIBRARY};${CMAKE_REQUIRED_LIBRARIES}")
     # Check for JACK MIDI headers availability.
     if (CONFIG_JACK_MIDI)
       check_include_file (jack/midiport.h HAVE_JACK_MIDIPORT_H)
@@ -179,12 +209,12 @@
     # Check for ALSA libraries.
     if (CONFIG_ALSA_MIDI)
       pkg_check_modules (ALSA IMPORTED_TARGET alsa)
-      set (CONFIG_ALSA_MIDI ${ALSA_FOUND})
-      if (CONFIG_ALSA_MIDI)
-        include_directories (${ALSA_INCLUDE_DIRS})
-        link_directories (${ALSA_LIBRARY_DIRS})
-        link_libraries (${ALSA_LIBRARIES})
-      # set (CMAKE_REQUIRED_LIBRARIES "${ALSA_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
+      if (ALSA_FOUND)
+        find_library (ALSA_LIBRARY NAMES ${ALSA_LIBRARIES} HINTS ${ALSA_LIBDIR})
+      endif ()
+      if (ALSA_LIBRARY)
+        set (CONFIG_ALSA_MIDI 1)
+       #set (CMAKE_REQUIRED_LIBRARIES "${ALSA_LIBRARY};${CMAKE_REQUIRED_LIBRARIES}")
       else ()
         message (WARNING "*** ALSA library not found.")
       endif ()
@@ -206,12 +236,7 @@
 # Check for RUBBERBAND libraries.
 if (CONFIG_LIBRUBBERBAND)
   pkg_check_modules (RUBBERBAND IMPORTED_TARGET rubberband)
-  if (RUBBERBAND_FOUND)
-    include_directories (${RUBBERBAND_INCLUDE_DIRS})
-    link_directories (${RUBBERBAND_LIBRARY_DIRS})
-    link_libraries (${RUBBERBAND_LIBRARIES})
-  # set (CMAKE_REQUIRED_LIBRARIES "${RUBBERBAND_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
-  else ()
+  if (NOT RUBBERBAND_FOUND)
     message (WARNING "*** RUBBERBAND library not found.")
     set (CONFIG_LIBRUBBERBAND 0)
   endif ()
@@ -220,12 +245,7 @@
 # Check for FFTW3 libraries.
 if (CONFIG_FFTW3)
   pkg_check_modules (FFTW3 IMPORTED_TARGET fftw3f)
-  if (FFTW3_FOUND)
-    include_directories (${FFTW3_INCLUDE_DIRS})
-    link_directories (${FFTW3_LIBRARY_DIRS})
-    link_libraries (${FFTW3_LIBRARIES})
-  # set (CMAKE_REQUIRED_LIBRARIES "${FFTW3_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
-  else ()
+  if (NOT FFTW3_FOUND)
     message (WARNING "*** FFTW3 library not found.")
     set (CONFIG_FFTW3 0)
   endif ()
@@ -234,12 +254,7 @@
 # Check for LIBLO libraries.
 if (CONFIG_LIBLO)
   pkg_check_modules (LIBLO IMPORTED_TARGET liblo)
-  if (LIBLO_FOUND)
-    include_directories (${LIBLO_INCLUDE_DIRS})
-    link_directories (${LIBLO_LIBRARY_DIRS})
-    link_libraries (${LIBLO_LIBRARIES})
-  # set (CMAKE_REQUIRED_LIBRARIES "${LIBLO_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
-  else ()
+  if (NOT LIBLO_FOUND)
     message (WARNING "*** LIBLO library not found.")
     set (CONFIG_LIBLO 0)
   endif ()
@@ -250,9 +265,6 @@
   pkg_check_modules (LV2 lv2)
   if (LV2_FOUND)
     include_directories (${LV2_INCLUDE_DIRS})
-    link_directories (${LV2_LIBRARY_DIRS})
-    link_libraries (${LV2_LIBRARIES})
-  # set (CMAKE_REQUIRED_LIBRARIES "${LV2_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
     # Check for LV2 Atom support.
     check_include_file (lv2/lv2plug.in/ns/ext/atom/atom.h HAVE_LV2_ATOM_H)
     if (NOT HAVE_LV2_ATOM_H)
@@ -271,6 +283,7 @@
     endif ()
     if (NOT CONFIG_LV2_UI)
       set (CONFIG_LV2_UI_X11 0)
+      set (CONFIG_LV2_UI_WINDOWS 0)
       set (CONFIG_LV2_UI_EXTERNAL 0)
       set (CONFIG_LV2_UI_IDLE 0)
       set (CONFIG_LV2_UI_SHOW 0)
@@ -289,12 +302,14 @@
   include_directories (${LV2_INCLUDES})
 else ()
   set (CONFIG_LV2_UI_X11 0)
+  set (CONFIG_LV2_UI_WINDOWS 0)
   set (CONFIG_LV2_UI_EXTERNAL 0)
   set (CONFIG_LV2_UI_IDLE 0)
   set (CONFIG_LV2_UI_SHOW 0)
   set (CONFIG_LV2_UI_RESIZE 0)
   set (CONFIG_LV2_PROGRAMS 0)
   set (CONFIG_LV2_PATCH 0)
+  set (CONFIG_LV2_PORT_EVENT 0)
 endif ()
 
 if (CONFIG_LV2_UI_EXTERNAL)
@@ -337,14 +352,18 @@
 endmacro ()
 
 
-message   ("\n  ${PACKAGE_NAME} ${PACKAGE_VERSION}")
+message   ("\n  ${PACKAGE_NAME} ${PACKAGE_VERSION} (Qt ${QT_VERSION})")
 message   ("\n  Build target . . . . . . . . . . . . . . . . . . .: ${CONFIG_BUILD_TYPE}\n")
 show_option ("  JACK stand-alone build . . . . . . . . . . . . . ." CONFIG_JACK)
 show_option ("  JACK session support . . . . . . . . . . . . . . ." CONFIG_JACK_SESSION)
 show_option ("  JACK MIDI support  . . . . . . . . . . . . . . . ." CONFIG_JACK_MIDI)
 show_option ("  ALSA MIDI support  . . . . . . . . . . . . . . . ." CONFIG_ALSA_MIDI)
 show_option ("  LV2 plug-in build  . . . . . . . . . . . . . . . ." CONFIG_LV2)
+if (WIN32)
+show_option ("  LV2 plug-in Windows UI support   . . . . . . . . ." CONFIG_LV2_UI_WINDOWS)
+else ()
 show_option ("  LV2 plug-in X11 UI support   . . . . . . . . . . ." CONFIG_LV2_UI_X11)
+endif ()
 show_option ("  LV2 plug-in External UI support  . . . . . . . . ." CONFIG_LV2_UI_EXTERNAL)
 show_option ("  LV2 plug-in UI Idle interface support  . . . . . ." CONFIG_LV2_UI_IDLE)
 show_option ("  LV2 plug-in UI Show interface support  . . . . . ." CONFIG_LV2_UI_SHOW)
@@ -353,4 +372,3 @@
 show_option ("  LV2 plug-in Patch support  . . . . . . . . . . . ." CONFIG_LV2_PATCH)
 show_option ("  LV2 plug-in Port-event support (EXPERIMENTAL)  . ." CONFIG_LV2_PORT_EVENT)
 show_option ("  Pitch-shifting support (librubberband) . . . . . ." CONFIG_LIBRUBBERBAND)
-show_option ("  Pitch-shifting support (fftw3) . . . . . . . . . ." CONFIG_FFTW3)

=== src/CMakeLists.txt ===
# project (samplv1)

set (CMAKE_INCLUDE_CURRENT_DIR ON)

set (CMAKE_AUTOUIC ON)
set (CMAKE_AUTOMOC ON)
set (CMAKE_AUTORCC ON)

if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
    file (REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
endif ()
configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

set (HEADERS
  samplv1.h
  samplv1_config.h
  samplv1_filter.h
  samplv1_formant.h
  samplv1_pshifter.h
  samplv1_resampler.h
  samplv1_sample.h
  samplv1_wave.h
  samplv1_ramp.h
  samplv1_list.h
  samplv1_fx.h
  samplv1_reverb.h
  samplv1_param.h
  samplv1_sched.h
  samplv1_tuning.h
  samplv1_programs.h
  samplv1_controls.h
)

set (SOURCES
  samplv1.cpp
  samplv1_config.cpp
  samplv1_formant.cpp
  samplv1_pshifter.cpp
  samplv1_resampler.cpp
  samplv1_sample.cpp
  samplv1_wave.cpp
  samplv1_param.cpp
  samplv1_sched.cpp
  samplv1_tuning.cpp
  samplv1_programs.cpp
  samplv1_controls.cpp
)


set (HEADERS_UI
  samplv1_ui.h
  samplv1widget.h
  samplv1widget_env.h
  samplv1widget_filt.h
  samplv1widget_sample.h
  samplv1widget_wave.h
  samplv1widget_param.h
  samplv1widget_keybd.h
  samplv1widget_preset.h
  samplv1widget_status.h
  samplv1widget_spinbox.h
  samplv1widget_programs.h
  samplv1widget_controls.h
  samplv1widget_control.h
  samplv1widget_palette.h
  samplv1widget_config.h
)

set (SOURCES_UI
  samplv1_ui.cpp
  samplv1widget.cpp
  samplv1widget_env.cpp
  samplv1widget_filt.cpp
  samplv1widget_sample.cpp
  samplv1widget_wave.cpp
  samplv1widget_param.cpp
  samplv1widget_keybd.cpp
  samplv1widget_preset.cpp
  samplv1widget_status.cpp
  samplv1widget_spinbox.cpp
  samplv1widget_programs.cpp
  samplv1widget_controls.cpp
  samplv1widget_control.cpp
  samplv1widget_palette.cpp
  samplv1widget_config.cpp
)

set (FORMS_UI
  samplv1widget.ui
  samplv1widget_control.ui
  samplv1widget_palette.ui
  samplv1widget_config.ui
)

set (RESOURCES_UI
  samplv1.qrc
)


set (HEADERS_LV2
  samplv1_lv2.h
  samplv1_lv2ui.h
  samplv1widget_lv2.h
)

set (SOURCES_LV2
  samplv1_lv2.cpp
  samplv1_lv2ui.cpp
  samplv1widget_lv2.cpp
)


set (HEADERS_JACK
  samplv1_nsm.h
  samplv1_jack.h
  samplv1widget_jack.h
)

set (SOURCES_JACK
  samplv1_nsm.cpp
  samplv1_jack.cpp
  samplv1widget_jack.cpp
)


add_library (${PROJECT_NAME} STATIC
  ${HEADERS}
  ${SOURCES}
)

add_library (${PROJECT_NAME}_ui STATIC
  ${HEADERS_UI}
  ${SOURCES_UI}
  ${FORMS_UI}
  ${RESOURCES_UI}
)


if (CONFIG_LV2)
  add_library (${PROJECT_NAME}_lv2 MODULE
    ${HEADERS_LV2}
    ${SOURCES_LV2}
  )
endif ()

if (CONFIG_JACK)
  add_executable (${PROJECT_NAME}_jack
    ${HEADERS_JACK}
    ${SOURCES_JACK}
  )
endif ()

set_target_properties (${PROJECT_NAME}    PROPERTIES CXX_STANDARD 17)
set_target_properties (${PROJECT_NAME}_ui PROPERTIES CXX_STANDARD 17)

if (QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
  target_compile_options (${PROJECT_NAME}    PRIVATE -fPIC)
  target_compile_options (${PROJECT_NAME}_ui PRIVATE -fPIC)
endif ()

# Add some debugger flags.
if (CONFIG_DEBUG AND CONFIG_JACK AND UNIX AND NOT APPLE)
  target_compile_options (${PROJECT_NAME}_jack PRIVATE -g -fsanitize=address -fno-omit-frame-pointer)
  target_link_libraries (${PROJECT_NAME}_jack PRIVATE asan)
endif ()

target_link_libraries (${PROJECT_NAME}    PUBLIC Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Xml)
target_link_libraries (${PROJECT_NAME}_ui PUBLIC Qt${QT_VERSION_MAJOR}::Widgets ${PROJECT_NAME})

if (CONFIG_SNDFILE)
  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::SNDFILE)
endif ()

if (CONFIG_LIBRUBBERBAND)
  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::RUBBERBAND)
endif ()

if (CONFIG_FFTW3)
  target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::FFTW3)
endif ()

if (CONFIG_LV2)
  set_target_properties (${PROJECT_NAME}_lv2 PROPERTIES CXX_STANDARD 17)
  target_link_libraries (${PROJECT_NAME}_lv2 PRIVATE ${PROJECT_NAME}_ui)
  target_include_directories (${PROJECT_NAME}_lv2 PRIVATE ${LV2_INCLUDE_DIRS})
  target_link_directories (${PROJECT_NAME}_lv2 PRIVATE ${LV2_LIBRARY_DIRS})
  target_link_libraries (${PROJECT_NAME}_lv2 PRIVATE ${LV2_LIBRARIES})
  if (UNIX AND NOT APPLE)
    if (NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME}_lv2  POST_BUILD
        COMMAND strip lib${PROJECT_NAME}_lv2.so)
    endif ()
    if (CONFIG_PREFIX MATCHES $ENV{HOME})
      set (CONFIG_LV2DIR ${CONFIG_PREFIX}/.lv2)
    else ()
      set (CONFIG_LV2DIR ${CONFIG_LIBDIR}/lv2)
    endif ()
    install (FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${PROJECT_NAME}_lv2.so
      RENAME ${PROJECT_NAME}.so
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
    install (FILES ${PROJECT_NAME}.lv2/manifest.ttl
      ${PROJECT_NAME}.lv2/${PROJECT_NAME}.ttl
      ${PROJECT_NAME}.lv2/${PROJECT_NAME}_ui.ttl
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
  endif ()
  if (WIN32)
    target_link_options (${PROJECT_NAME}_lv2 PRIVATE -static-libgcc -static-libstdc++)
    if (NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME}_lv2  POST_BUILD
        COMMAND strip lib${PROJECT_NAME}_lv2.dll)
    endif ()
    set (CONFIG_LV2DIR ${CONFIG_WINDOWS_LV2_PATH})
    install (FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${PROJECT_NAME}_lv2.dll
      RENAME ${PROJECT_NAME}.dll
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
    install (FILES ${PROJECT_NAME}.lv2/manifest-win32.ttl
      RENAME manifest.ttl
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
    install (FILES ${PROJECT_NAME}.lv2/${PROJECT_NAME}.ttl
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
    install (FILES ${PROJECT_NAME}.lv2/${PROJECT_NAME}_ui-win32.ttl
      RENAME ${PROJECT_NAME}_ui.ttl
      DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}.lv2)
  endif ()
endif ()

if (CONFIG_JACK)
  set_target_properties (${PROJECT_NAME}_jack PROPERTIES CXX_STANDARD 17)
  target_link_libraries (${PROJECT_NAME}_jack PRIVATE ${PROJECT_NAME}_ui)
  target_link_libraries (${PROJECT_NAME}_jack PRIVATE PkgConfig::JACK)
  if (CONFIG_ALSA_MIDI)
    target_link_libraries (${PROJECT_NAME}_jack PRIVATE PkgConfig::ALSA)
  endif ()
  if (CONFIG_LIBLO)
    target_link_libraries (${PROJECT_NAME}_jack PRIVATE PkgConfig::LIBLO)
  endif ()
  if (UNIX AND NOT APPLE)
    if (NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME}_jack POST_BUILD
        COMMAND strip ${PROJECT_NAME}_jack)
    endif ()
    install (TARGETS ${PROJECT_NAME}_jack RUNTIME
      DESTINATION ${CMAKE_INSTALL_BINDIR})
    install (FILES ${PROJECT_NAME}.desktop
      DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install (FILES images/${PROJECT_NAME}.png
      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps)
    install (FILES images/${PROJECT_NAME}.svg
      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
    install (FILES appdata/${PROJECT_NAME}.appdata.xml
      DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)
    install (FILES mimetypes/${PROJECT_NAME}.xml
      DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages)
    install (FILES mimetypes/application-x-${PROJECT_NAME}-preset.png
      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/mimetypes)
    install (FILES mimetypes/application-x-${PROJECT_NAME}-preset.svg
      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/mimetypes)
  endif ()
endif ()

=== debian/changelog ===
samplv1 (0.9.23-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 04 Oct 2021 16:25:02 -0400

samplv1 (0.9.23-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since stretch

  [ Dennis Braun ]
  * New upstream version 0.9.23
  * Bump Standards-Version to 4.6.0
  * debian/rules: Atm debian archive has no qt6, we compile with --disable-qt6

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 23 Aug 2021 00:01:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: samplv1
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Dennis Braun <d_braun@kabelmail.de>,
  Alessio Treglia <alessio@debian.org>,
@@ -20,7 +21,7 @@
  lv2-dev,
  liblo-dev,
 Homepage: https://samplv1.sourceforge.io/
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/multimedia-team/samplv1.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/samplv1
 Rules-Requires-Root: no
@@ -50,8 +51,6 @@
  ${misc:Depends},
  ${shlibs:Depends},
  samplv1-common (=${source:Version}),
-Replaces: samplv1 (<< 0.7.6)
-Breaks: samplv1 (<< 0.7.6)
 Provides:
  lv2-plugin
 Description: polyphonic sampler synthesizer - LV2 plugin
@@ -70,8 +69,6 @@
 Multi-Arch: foreign
 Depends:
  ${misc:Depends},
-Replaces: samplv1 (<< 0.7.6)
-Breaks: samplv1 (<< 0.7.6)
 Description: polyphonic sampler synthesizer - common files
  samplv1 is an old-school all-digital polyphonic sampler
  synthesizer with stereo effects.

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,8 @@
  --enable-jack \
  --enable-jack-midi \
  --enable-jack-session \
- --enable-lv2
+ --enable-lv2 \
+ --disable-qt6
 
 export QTDIR=/usr/share/qt5
 export QT_SELECT=qt5
@@ -22,6 +23,9 @@
 
 %:
 	dh $@
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(EXTRA_CONFIGURE_ARGS)
